SystemOrganization addCategory: #'Iliad-More-Formula'!

ILWidget subclass: #ILFormula
	instanceVariableNames: 'model fields buttons saveAction cancelAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILFormula class methodsFor: 'instance creation' stamp: 'sa 1/4/2010 16:18'!
on: anObject
	^self new
		setModel: anObject;
		yourself! !

!ILFormula methodsFor: 'adding' stamp: 'sa 1/4/2010 16:22'!
addField: aField
	^self fields add: aField! !

!ILFormula methodsFor: 'adding' stamp: 'StevenCostiou 1/15/2010 21:56'!
autoCompleteInputOn: aSelector
	^self addField: (ILAutocompleteIntputField on: aSelector of: model)! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:19'!
buttons
	^buttons ifNil: [self defaultButtons]! !

!ILFormula methodsFor: 'accessing' stamp: 'StevenCostiou 1/20/2010 20:30'!
buttons: aCollection
	buttons := aCollection ! !

!ILFormula methodsFor: 'building' stamp: 'StevenCostiou 1/16/2010 20:42'!
buttonsContents
	^[:form |
		self buttons do: [:each |
			form button
				text: each key;
				action: [self perform: each value]]] ! !

!ILFormula methodsFor: 'actions' stamp: 'sa 3/6/2010 12:58'!
cancel
	self cancelAction valueWithPossibleArgument: model! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:51'!
cancelAction
	^cancelAction ifNil: [self defaultCancelAction]! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:51'!
cancelAction: aBlock
	cancelAction := aBlock! !

!ILFormula methodsFor: 'adding' stamp: 'sa 1/4/2010 16:27'!
checkboxOn: aSelector
	^self addField: (ILCheckboxField on: aSelector of: model)! !

!ILFormula methodsFor: 'enumerating' stamp: 'StevenCostiou 1/16/2010 20:02'!
collect: aBlock
	^self copy
		setFields: (self fields collect: aBlock);
		yourself! !

!ILFormula methodsFor: 'actions' stamp: 'sa 1/4/2010 16:38'!
commit
	self fields do: [:each | 
		each commit]! !

!ILFormula methodsFor: 'building' stamp: 'StevenCostiou 1/20/2010 20:40'!
contents
	^[:e | 
		(e div class: 'formula')
		form build: [:form |
			form multipart: self isMultipart. 
			form table tbody build: self tableContents.
			form div 
				class: 'buttons';
				build: self buttonsContents]]! !

!ILFormula methodsFor: 'adding' stamp: 'sa 1/4/2010 16:29'!
dateInputOn: aSelector
	^self addField: (ILDateInputField on: aSelector of: model)! !

!ILFormula methodsFor: 'defaults' stamp: 'StevenCostiou 1/16/2010 20:41'!
defaultButtons
	^{'Save' -> #save. 'Cancel' -> #cancel}! !

!ILFormula methodsFor: 'defaults' stamp: 'sa 3/6/2010 12:53'!
defaultCancelAction
	^[:model | self answer: nil]! !

!ILFormula methodsFor: 'defaults' stamp: 'sa 3/6/2010 12:52'!
defaultSaveAction
	^[:model | self answer: model]! !

!ILFormula methodsFor: 'enumerating' stamp: 'StevenCostiou 1/16/2010 20:01'!
do: aBlock
	^self fields do: aBlock ! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:19'!
fields
	^fields ifNil: [fields := OrderedCollection new]! !

!ILFormula methodsFor: 'adding' stamp: 'StevenCostiou 1/16/2010 21:54'!
fileInputOn: aSelector
	^self addField: (ILFileInputField on: aSelector of: model)! !

!ILFormula methodsFor: 'adding' stamp: 'sa 1/4/2010 16:24'!
inputOn: aSelector
	^self addField: (ILInputField on: aSelector of: model)! !

!ILFormula methodsFor: 'testing' stamp: 'StevenCostiou 1/16/2010 22:42'!
isEmpty
	^self fields isEmpty! !

!ILFormula methodsFor: 'testing' stamp: 'StevenCostiou 1/20/2010 20:41'!
isMultipart 
	^(self fields select: [:each | each isMultipart]) notEmpty ! !

!ILFormula methodsFor: 'testing' stamp: 'sa 1/4/2010 16:45'!
isValid
	self fields do: [:each |
		each isValid ifFalse: [^false]].
	^true! !

!ILFormula methodsFor: 'adding' stamp: 'StevenCostiou 1/24/2010 23:02'!
multipleCheckBoxOn: aSelector
	^self addField: (ILMultipleCheckboxField on: aSelector of: model)! !

!ILFormula methodsFor: 'adding' stamp: 'sa 1/4/2010 16:28'!
passwordOn: aSelector
	^self addField: (ILPasswordField on: aSelector of: model)! !

!ILFormula methodsFor: 'enumerating' stamp: 'StevenCostiou 1/16/2010 20:10'!
reject: aBlock
	^self copy
		setFields: (self fields reject: aBlock);
		yourself! !

!ILFormula methodsFor: 'actions' stamp: 'sa 3/6/2010 12:57'!
save
	self
		validate;
		markDirty.
	self isValid ifTrue: [
		self commit.
		self saveAction valueWithPossibleArgument: model]! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:50'!
saveAction
	^saveAction ifNil: [self defaultSaveAction]! !

!ILFormula methodsFor: 'accessing' stamp: 'sa 3/6/2010 12:50'!
saveAction: aBlock
		saveAction := aBlock! !

!ILFormula methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 21:58'!
scripts
	^{'/javascripts/jquery.autocomplete.js'}! !

!ILFormula methodsFor: 'enumerating' stamp: 'StevenCostiou 1/16/2010 20:09'!
select: aBlock
	^self copy
		setFields: (self fields select: aBlock);
		yourself! !

!ILFormula methodsFor: 'adding' stamp: 'sa 1/4/2010 16:30'!
selectOn: aSelector
	^self addField: (ILSelectField on: aSelector of: model)! !

!ILFormula methodsFor: 'accessing' stamp: 'StevenCostiou 1/16/2010 20:01'!
setFields: aCollection
	fields := aCollection ! !

!ILFormula methodsFor: 'private' stamp: 'sa 1/4/2010 16:46'!
setModel: anObject
	model := anObject! !

!ILFormula methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 21:58'!
styles
	^{'/stylesheets/jquery.autocomplete.css'}
	! !

!ILFormula methodsFor: 'building' stamp: 'np 1/4/2010 18:35'!
tableContents
	^[:tbody | 
		self fields do: [:each |
			tbody build: each]]! !

!ILFormula methodsFor: 'adding' stamp: 'sa 1/4/2010 16:25'!
textareaOn: aSelector
	^self addField: (ILTextareaField on: aSelector of: model)! !

!ILFormula methodsFor: 'actions' stamp: 'sa 1/4/2010 16:42'!
validate
	self fields do: [:each | each validate]! !

Object subclass: #ILCondition
	instanceVariableNames: 'labelBlock conditionBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILCondition methodsFor: 'accessing' stamp: 'np 1/4/2010 18:31'!
conditionBlock
	^conditionBlock! !

!ILCondition methodsFor: 'accessing' stamp: 'np 1/4/2010 18:31'!
conditionBlock: aBlock
	conditionBlock := aBlock! !

!ILCondition methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:03'!
labelBlock
	^labelBlock! !

!ILCondition methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:03'!
labelBlock: aBlock
	labelBlock := aBlock! !

!ILCondition methodsFor: 'validating' stamp: 'sa 1/4/2010 16:07'!
labelFor: anObject
	^self labelBlock value: anObject! !

!ILCondition methodsFor: 'validating' stamp: 'np 1/4/2010 18:31'!
validate: anObject
	^self conditionBlock value: anObject! !

ILBuildable subclass: #ILField
	instanceVariableNames: 'conditions errors key labelContents value action commentContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

ILField subclass: #ILAutocompleteIntputField
	instanceVariableNames: 'options fieldId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILAutocompleteIntputField methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 22:08'!
completerScript
	| str |
	str := WriteStream on: ''.
	str nextPutAll: 'jQuery(''#', fieldId , ''').autocomplete('.
	str nextPut: $[.
	self options do: [:each |
		str nextPutAll: '"' , each ,'"']
		separatedBy: [str nextPut: $,].
	str nextPutAll: '])'.
	^str contents
	! !

!ILAutocompleteIntputField methodsFor: 'building' stamp: 'StevenCostiou 1/15/2010 22:09'!
fieldContents
	^[:e |
		e input
			id: fieldId;
			value: (self value ifNil: ['']);
			action: [:val | self value: val].
		e script: self completerScript]! !

!ILAutocompleteIntputField methodsFor: 'initialization' stamp: 'StevenCostiou 1/16/2010 22:41'!
initialize 
	super initialize.
	fieldId := ILId new! !

!ILAutocompleteIntputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/15/2010 22:04'!
options
	^options ifNil: [#()]! !

!ILAutocompleteIntputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/15/2010 22:04'!
options: aCollection
	options := aCollection ! !

ILField subclass: #ILCheckboxField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILCheckboxField methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:48'!
fieldContents
	^[:e | 
		e checkbox
			checked: (self value ifNil: [false]);
			action: [:boolean | self value: boolean]]! !

ILField subclass: #ILDateInputField
	instanceVariableNames: 'month day year yearsInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:07'!
date
	^Date 
		newDay: self day
		month: self month
		year: self year! !

!ILDateInputField methodsFor: 'accessing' stamp: 'np 4/5/2010 17:34'!
date: aDate
	self month: aDate monthName greaseString.
	self day: aDate dayOfMonth.
	self year: aDate year! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:11'!
day
	^day! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:11'!
day: anInteger
	day := anInteger! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:14'!
days
	^1 to: 31! !

!ILDateInputField methodsFor: 'building' stamp: 'np 4/5/2010 17:40'!
fieldContents
	^[:e | 
		e select build: [:select |
			self months do: [:each | 
				select option
					text: each;
					action: [self month: each];
					selected: (self month = each)]].
		e select build: [:select |
			self days do: [:each | 
				select option 
					text: each greaseString;
					action: [self day: each];
					selected: (self day = each)]].
		e select build: [:select | 
			self years do: [:each |
				select option
					text: each greaseString;
					action: [self year: each];
					selected: (self year = each)]].
		e input beHidden
			action: [:val | self value: self date]]! !

!ILDateInputField methodsFor: 'initialization' stamp: 'sa 1/4/2010 18:03'!
initialize
	super initialize.
	self value: Date today.! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:08'!
month
	^month! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:10'!
month: aString
	month := aString! !

!ILDateInputField methodsFor: 'accessing' stamp: 'np 4/5/2010 17:35'!
months
	^(1 to: 12) collect: [:each | (Date nameOfMonth: each) greaseString]! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:06'!
value: aDate
	super value: aDate.
	self date: aDate! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:11'!
year
	^year! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:11'!
year: anInteger
	year := anInteger! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:15'!
years
	^self yearsInterval! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:05'!
yearsInterval
	^yearsInterval ifNil: [
		(Date today year - 20) to: (Date today year + 20)]! !

!ILDateInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 18:05'!
yearsInterval: anInterval
	yearsInterval := anInterval! !

!ILField class methodsFor: 'instance creation' stamp: 'sa 1/4/2010 15:20'!
on: aSelector of: anObject
	^self new
		on: aSelector
		of: anObject;
		yourself! !

!ILField methodsFor: 'conditions' stamp: 'sa 1/4/2010 15:26'!
addCondition: aCondition
	self conditions add: aCondition! !

!ILField methodsFor: 'conditions' stamp: 'sa 1/4/2010 15:40'!
addCondition: aBlock labelled: anotherBlock
	self addCondition: (ILCondition new
		conditionBlock: aBlock;
		labelBlock: anotherBlock;
		yourself)! !

!ILField methodsFor: 'building' stamp: 'sa 1/4/2010 15:43'!
buildContents
	^ILXHTMLElement new
		build: self tableRowContents;
		yourself! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:37'!
comment: aString
	self commentContents: [:e | e text: aString]! !

!ILField methodsFor: 'accessing' stamp: 'StevenCostiou 1/16/2010 21:48'!
commentContents 
	^commentContents
		! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:37'!
commentContents: aBlock
	commentContents := aBlock! !

!ILField methodsFor: 'actions' stamp: 'np 1/4/2010 18:37'!
commit
	action value: self value! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:24'!
conditions
	^conditions ifNil: [conditions := OrderedCollection new]! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:39'!
errors
	^errors ifNil: [{}]! !

!ILField methodsFor: 'building' stamp: 'sa 1/4/2010 15:50'!
errorsContents
	^[:tbody |
		self errors notEmpty ifTrue: [
			tbody tr build: [:tr |
				tr td.
				tr td div
					class: 'errors';
					build: [:div |
						div text: self errors first]]]]! !

!ILField methodsFor: 'building' stamp: 'sa 1/4/2010 15:47'!
fieldContents
	self subclassResponsibility! !

!ILField methodsFor: 'testing' stamp: 'StevenCostiou 1/20/2010 20:36'!
isMultipart 
	^false! !

!ILField methodsFor: 'testing' stamp: 'sa 1/4/2010 15:52'!
isValid
	^self errors isEmpty! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:20'!
key
	^key! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:21'!
key: aSymbol
	key := aSymbol ! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:22'!
label: aString
	self labelContents: [:e | e text: aString]! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:22'!
labelContents
	^labelContents! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:22'!
labelContents: aBlock
	labelContents := aBlock! !

!ILField methodsFor: 'private' stamp: 'np 4/5/2010 17:36'!
on: aSelector of: anObject
	key ifNil: [key := aSelector].
	labelContents ifNil: [self label: aSelector greaseString].
	value := anObject perform: aSelector.
	action := [:val | 
		anObject perform: (aSelector, ':') asSymbol with: val] ! !

!ILField methodsFor: 'accessing' stamp: 'StevenCostiou 1/16/2010 19:38'!
setAction: aBlock
	action := aBlock ! !

!ILField methodsFor: 'building' stamp: 'StevenCostiou 1/27/2010 19:03'!
tableRowContents
	^[:tbody |
		tbody tr build: [:tr |
			tr cssClass: 'field'.
			self isValid ifFalse: [
				tr cssClass: tr cssClass, ' error'].
			tr th
				build: self labelContents.
			tr td
				build: self fieldContents].
		self commentContents ifNotNil:[
			tbody tr build: [:tr | 
				tr td.
				tr td
					cssClass: 'comment';
					build: self commentContents]].
		tbody build: self errorsContents]! !

!ILField methodsFor: 'actions' stamp: 'np 1/4/2010 18:35'!
validate
	errors := OrderedCollection new.
	self conditions do: [:each | 
		(each validate: self value) ifFalse: [
			self errors add: (each labelFor: self value)]]! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:23'!
value
	^value! !

!ILField methodsFor: 'accessing' stamp: 'sa 1/4/2010 15:23'!
value: anObject
	value := anObject! !

ILField subclass: #ILFileInputField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILFileInputField methodsFor: 'building' stamp: 'StevenCostiou 1/20/2010 20:42'!
fieldContents
	^[:e |
		(self value isNil or: [self value isString]) 
			ifTrue: [e build: self uploadContents]
			ifFalse: [e build: self fileContents]]! !

!ILFileInputField methodsFor: 'building' stamp: 'StevenCostiou 1/16/2010 22:39'!
fileContents
	^[:e |		
		e text: self value filename]! !

!ILFileInputField methodsFor: 'testing' stamp: 'StevenCostiou 1/20/2010 20:41'!
isMultipart 
	^true! !

!ILFileInputField methodsFor: 'building' stamp: 'sa 3/6/2010 12:49'!
uploadContents
	^[:e |
		e file action: [:val | self value: val]]! !

ILField subclass: #ILInputField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILInputField methodsFor: 'accessing' stamp: 'sa 1/4/2010 16:50'!
fieldContents
	^[:e | 
		e input 
			value: (self value ifNil: ['']);
			action: [:val | self value: val]]! !

ILField subclass: #ILOptionField
	instanceVariableNames: 'options optionLabelBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

ILOptionField subclass: #ILMultipleCheckboxField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILMultipleCheckboxField methodsFor: 'building' stamp: 'StevenCostiou 1/24/2010 22:02'!
fieldContents
	^[:e |
		self options do:[:each |
			e checkbox 
				checked: (self value includes: each);
				action: [:boolean | 
					boolean 
					ifTrue: [self add: each]
					ifFalse: [self remove: each]].
				e space.
				e label text: (self optionLabelBlock value: each)]
			separatedBy: [e br]]! !

!ILOptionField methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 23:20'!
add: anObject
	(self value includes: anObject)
		ifFalse: [self value add: anObject]! !

!ILOptionField methodsFor: 'defaults' stamp: 'np 4/5/2010 17:41'!
defaultOptionLabelBlock
	^[:option | 
		option isString
			ifTrue: [option]
			ifFalse: [option greaseString]]! !

!ILOptionField methodsFor: 'testing' stamp: 'StevenCostiou 1/24/2010 23:03'!
isMultiple
	^true! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:42'!
optionLabelBlock
	^optionLabelBlock ifNil: [self defaultOptionLabelBlock]! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:45'!
optionLabelBlock: aBlock
	optionLabelBlock := aBlock! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:48'!
options
	^options ifNil: [{}]! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:51'!
options: aCollection
	options := aCollection! !

!ILOptionField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:52'!
options: aCollection labels: aBlock
	self options: aCollection.
	self optionLabelBlock: aBlock! !

!ILOptionField methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 23:04'!
remove: anObject
	(self value includes: anObject)
		ifTrue: [self value remove: anObject]! !

!ILOptionField methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 23:03'!
value
	(value isNil and: [self isMultiple]) ifTrue:[
		value := OrderedCollection new].
	^value! !

ILOptionField subclass: #ILSelectField
	instanceVariableNames: 'multiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILSelectField methodsFor: 'building' stamp: 'StevenCostiou 1/24/2010 23:25'!
fieldContents
	^[:e | 
		e select build: [:select |
			self isMultiple ifTrue: [
				select beMultiple].
			self options do: [:each | 
				select option
					selected: (self isMultiple
						ifTrue: [self value includes: each]
						ifFalse: [self value = each]);
					text: (self optionLabelBlock value: each);
					action: [self isMultiple 
						ifFalse: [self value: each]
						ifTrue: [self add: each]]]]]! !

!ILSelectField methodsFor: 'testing' stamp: 'StevenCostiou 1/24/2010 23:08'!
isMultiple
	^self multiple! !

!ILSelectField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:54'!
multiple
	^multiple! !

!ILSelectField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:54'!
multiple: aBoolean
	multiple := aBoolean! !

ILField subclass: #ILPasswordField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILPasswordField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:32'!
fieldContents
	^[:e | 
		e password
			value: (self value ifNil: ['']);
			action: [:val | self value: val]]	! !

ILField subclass: #ILTextareaField
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILTextareaField methodsFor: 'building' stamp: 'sa 1/4/2010 17:38'!
fieldContents
	^[:e | 
		e textarea build: [:textarea |
			self size ifNotNil: [
				textarea
					cols: self size x;
					rows: self size y].
			textarea
				text: (self value ifNil: ['']);
				action: [:val | self value: val]]]! !

!ILTextareaField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:34'!
size
	^size! !

!ILTextareaField methodsFor: 'accessing' stamp: 'sa 1/4/2010 17:34'!
size: aPoint
	size := aPoint! !

ILField subclass: #ILTimeInputField
	instanceVariableNames: 'hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Formula'!

!ILTimeInputField methodsFor: 'building' stamp: 'np 4/5/2010 17:42'!
fieldContents
	^[:e | 
		e select build: [:select | 
			(1 to: 24) do: [:each | 
				select option 
					text: each greaseString;
					action: [self hours: each];
					selected: self hours = each]].
		e select build: [:select | 
			(1 to: 60) do: [:each | 
				select option 
					text: each greaseString;	
					action: [self minutes: each];
					selected: self minutes = each]].
		e select build: [:select | 
			(1 to: 60) do: [:each | 
				select option 
					text: each greaseString;	
					action: [self seconds: each];
					selected: self seconds = each]].
		e input beHidden
			action: [:val | self value: self time]]! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:08'!
hours
	^hours! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:10'!
hours: anInteger
	hours := anInteger! !

!ILTimeInputField methodsFor: 'initialization' stamp: 'StevenCostiou 1/5/2010 17:10'!
initialize
	super initialize.
	self value: Time now! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:09'!
minutes
	^minutes! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:10'!
minutes: anInteger
	minutes := anInteger! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:09'!
seconds
	^seconds! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:10'!
seconds: anInteger
	seconds := anInteger! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'np 1/5/2010 17:09'!
time
	^Time 
		hour: self hours
		minute: self minutes
		second: self seconds! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:27'!
time: aTime 
	self hours: aTime hours.
	self minutes: aTime minutes.
	self seconds: aTime seconds! !

!ILTimeInputField methodsFor: 'accessing' stamp: 'StevenCostiou 1/5/2010 17:12'!
value: aTime 
	super value: aTime.
	self time: aTime! !
